﻿namespace UltraGridCellCollSpan
{
    using System;
    using System.Data;
    using System.Windows.Forms;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        private int rows;
        private int cols;
        private int commentColIndex;
        private int keyColIndex;

        public Form1()
        {
            this.InitializeComponent();
            this.rows = 1000;
            this.cols = 6;
            this.commentColIndex = 3;
            this.keyColIndex = 0;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.SetDataBinding(this.GetData(this.rows, this.cols, this.commentColIndex, this.keyColIndex), null);
            this.ultraGrid1.CreationFilter = new MyCreationFilter();
            this.ultraGrid1.DisplayLayout.Override.CellClickAction = CellClickAction.Edit;
        }

        private object GetData(int rows, int cols, int commentColIndex, int keyColIndex)
        {
            DataTable dt = new DataTable();

            for (int col = 0; col < cols; col++)
            {
                if (col == keyColIndex)
                {
                    dt.Columns.Add("KEY");
                }
                else if (col == commentColIndex)
                {
                    dt.Columns.Add("COMMENT");
                }
                else
                {
                    dt.Columns.Add(string.Format("Test{0}", col + 1));
                }
            }

            for (int row = 0; row < rows; row++)
            {
                DataRow addRow = dt.NewRow();
                foreach (DataColumn column in dt.Columns)
                {
                    if (row % 7 == 0)
                    {
                        if (column.Caption == "KEY")
                        {
                            addRow[column] = "*";
                            continue;
                        }

                        if (column.Caption == "COMMENT")
                        {
                            addRow[column] = string.Format("Comment for row #{0}", row + 1);
                            continue;
                        }
                    }

                    addRow[column] = string.Format("{0}.{1}", row + 1, column.Ordinal + 1);
                }

                dt.Rows.Add(addRow);
            }

            return dt;
        }
    }
}
