﻿namespace UltraGridCellCollSpan
{
    using System.Drawing;
    using Infragistics.Win;

    using Infragistics.Win.UltraWinGrid;

    internal class MyCreationFilter : IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent)
        {
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            CellUIElement cellElement = parent as CellUIElement;

            if (cellElement != null)
            {
                UltraGridCell commentCell = cellElement.GetContext(typeof(UltraGridCell)) as UltraGridCell;
                UltraGridCell keyCell = commentCell.Row.Cells["KEY"];
                if (keyCell.Value.ToString() == "*")
                {
                    if (commentCell.Column.Header.Caption == "COMMENT")
                    {
                        UIElement keyCellElement = keyCell.GetUIElement();
                        int keyCellWidth = 1;
                        if (keyCellElement != null)
                        {
                            keyCellWidth += keyCellElement.Rect.Width;
                        }

                        int w = cellElement.Parent.Rect.Width - keyCellWidth;
                        cellElement.Rect = new Rectangle(
                            cellElement.Parent.Rect.X + keyCell.Column.Width - 1,
                            cellElement.Rect.Y,
                            w,
                            cellElement.Rect.Height);
                    }
                    else if (commentCell.Column.Header.Caption != "KEY")
                    {
                        cellElement.Parent.ChildElements.Remove(cellElement);
                    }
                }
            }

            return false;
        }
    }
}