﻿Imports Infragistics.Win.UltraWinGrid

Public Class Form1
    Inherits Form
    Private rows As Integer
    Private cols As Integer
    Private commentColIndex As Integer
    Private keyColIndex As Integer

    Public Sub New()
        Me.InitializeComponent()
        Me.rows = 1000
        Me.cols = 6
        Me.commentColIndex = 3
        Me.keyColIndex = 0
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.UltraGrid1.SetDataBinding(Me.GetData(Me.rows, Me.cols, Me.commentColIndex, Me.keyColIndex), Nothing)
        Me.UltraGrid1.CreationFilter = New MyCreationFilter()
        Me.UltraGrid1.DisplayLayout.Override.CellClickAction = CellClickAction.Edit
    End Sub

    Private Function GetData(rows As Integer, cols As Integer, commentColIndex As Integer, keyColIndex As Integer) As Object
        Dim dt As New DataTable()

        For col As Integer = 0 To cols - 1
            If col = keyColIndex Then
                dt.Columns.Add("KEY")
            ElseIf col = commentColIndex Then
                dt.Columns.Add("COMMENT")
            Else
                dt.Columns.Add(String.Format("Test{0}", col + 1))
            End If
        Next

        For row As Integer = 0 To rows - 1
            Dim addRow As DataRow = dt.NewRow()
            For Each column As DataColumn In dt.Columns
                If row Mod 7 = 0 Then
                    If column.Caption = "KEY" Then
                        addRow(column) = "*"
                        Continue For
                    End If

                    If column.Caption = "COMMENT" Then
                        addRow(column) = String.Format("Comment for row #{0}", row + 1)
                        Continue For
                    End If
                End If

                addRow(column) = String.Format("{0}.{1}", row + 1, column.Ordinal + 1)
            Next

            dt.Rows.Add(addRow)
        Next

        Return dt
    End Function
End Class
